Index: trunk/examples/extended/hadronic/Hadr01/src/DetectorConstruction.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/DetectorConstruction.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/DetectorConstruction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorConstruction.cc,v 1.6 2006/10/04 09:56:03 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 /////////////////////////////////////////////////////////////////////////
Index: trunk/examples/extended/hadronic/Hadr01/src/DetectorMessenger.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/DetectorMessenger.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/DetectorMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.cc,v 1.7 2007/05/16 11:43:30 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 /////////////////////////////////////////////////////////////////////////
Index: trunk/examples/extended/hadronic/Hadr01/src/EventAction.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/EventAction.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/EventAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventAction.cc,v 1.4 2007/05/16 11:43:30 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 /////////////////////////////////////////////////////////////////////////
Index: trunk/examples/extended/hadronic/Hadr01/src/EventActionMessenger.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/EventActionMessenger.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/EventActionMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.cc,v 1.3 2006/06/29 17:24:11 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 /////////////////////////////////////////////////////////////////////////
Index: trunk/examples/extended/hadronic/Hadr01/src/Histo.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/Histo.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/Histo.cc	(revision 1230)
@@ -51,9 +51,9 @@
   verbose    = ver;
   histName   = "histo";
-  histType   = "hbook";
+  histType   = "root";
   option     = "--noErrors uncompress";
   nHisto     = 0;
   defaultAct = 1;
-  tupleName  = "tuple.hbook";
+  tupleName  = "tree.root";
   tupleId    = "100";
   tupleList  = "";
Index: trunk/examples/extended/hadronic/Hadr01/src/HistoManager.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/HistoManager.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/HistoManager.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: HistoManager.cc,v 1.14 2007/05/24 13:52:31 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// $Id: HistoManager.cc,v 1.16 2009/09/02 10:21:32 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //---------------------------------------------------------------------------
@@ -90,5 +90,5 @@
   nSlices   = 300;
   nBinsE    = 100;
-  nHisto    = 22;
+  nHisto    = 25;
   length    = 300.*mm;
   edepMax   = 1.0*GeV;
@@ -133,6 +133,12 @@
   histo->add1D("20","Log10 Energy (MeV) of pi+",nBinsE,-4.,6.,1.0);
   histo->add1D("21","Log10 Energy (MeV) of pi-",nBinsE,-4.,6.,1.0);
-  histo->add1D("22","Energy deposition (GeV) in the target",
-	       nBinsE,0.0,edepMax,GeV);
+  histo->add1D("22","Energy deposition in the target normalized to beam energy",
+	       110,0.0,1.1,1.0);
+  histo->add1D("23","EM energy deposition in the target normalized to beam energy",
+	       110,0.0,1.1,1.0);
+  histo->add1D("24","Pion energy deposition in the target normalized to beam energy",
+	       110,0.0,1.1,1.0);
+  histo->add1D("25","Proton energy deposition in the target normalized to beam energy",
+	       110,0.0,1.1,1.0);
 }
 
@@ -256,4 +262,7 @@
 {
   edepEvt = 0.0;
+  edepEM  = 0.0;
+  edepPI  = 0.0;
+  edepP   = 0.0;
 }
 
@@ -264,5 +273,8 @@
   edepSum  += edepEvt;
   edepSum2 += edepEvt*edepEvt;
-  histo->fill(21,edepEvt,1.0);
+  histo->fill(21,edepEvt/primaryKineticEnergy,1.0);
+  histo->fill(22,edepEM/primaryKineticEnergy,1.0);
+  histo->fill(23,edepPI/primaryKineticEnergy,1.0);
+  histo->fill(24,edepP/primaryKineticEnergy,1.0);
 }
 
@@ -372,4 +384,14 @@
     edepEvt += edep;
     histo->fill(0,z,edep);
+    const G4ParticleDefinition* pd = currentDef;
+
+    if(pd == G4Gamma::Gamma() || pd == G4Electron::Electron() 
+       || pd == G4Positron::Positron()) {
+      edepEM += edep;
+    } else if ( pd == G4PionPlus::PionPlus() || pd == G4PionMinus::PionMinus()) {
+      edepPI += edep;
+    } else if ( pd == G4Proton::Proton() || pd == G4AntiProton::AntiProton()) {
+      edepP  += edep;
+    }
 
     if(1 < verbose) 
Index: trunk/examples/extended/hadronic/Hadr01/src/HistoMessenger.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/HistoMessenger.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/HistoMessenger.cc	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: HistoMessenger.cc,v 1.5 2006/06/29 17:24:18 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 /////////////////////////////////////////////////////////////////////////
Index: trunk/examples/extended/hadronic/Hadr01/src/PhysicsList.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/PhysicsList.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/PhysicsList.cc	(revision 1230)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: PhysicsList.cc,v 1.24 2007/12/12 12:00:24 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysicsList.cc,v 1.31 2009/08/28 09:21:34 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 /////////////////////////////////////////////////////////////////////////
@@ -45,4 +45,5 @@
 
 #include "G4DecayPhysics.hh"
+#include "G4EmStandardPhysics_option3.hh"
 #include "G4EmStandardPhysics_option2.hh"
 #include "G4EmStandardPhysics_option1.hh"
@@ -52,4 +53,5 @@
 #include "G4HadronQElasticPhysics.hh"
 #include "G4HadronHElasticPhysics.hh"
+#include "G4ChargeExchangePhysics.hh"
 #include "G4NeutronTrackingCut.hh"
 #include "G4QStoppingPhysics.hh"
@@ -60,15 +62,15 @@
 #include "G4EmProcessOptions.hh"
 
-#include "HadronPhysicsFTFC.hh"
+#include "HadronPhysicsFTFP_BERT_TRV.hh"
 #include "HadronPhysicsFTFP.hh"
 #include "HadronPhysicsFTFP_BERT.hh"
+#include "HadronPhysicsFTF_BIC.hh"
 #include "HadronPhysicsLHEP.hh"
-#include "HadronPhysicsLHEP_BERT.hh"
 #include "HadronPhysicsLHEP_EMV.hh"
-#include "HadronPhysicsLHEP_PRECO_HP.hh"
 #include "G4HadronInelasticQBBC.hh"
 #include "HadronPhysicsQGSC.hh"
 #include "HadronPhysicsQGSC_BERT.hh"
-#include "HadronPhysicsQGSC_EFLOW.hh"
+#include "HadronPhysicsQGSC_CHIPS.hh"
+#include "HadronPhysicsQGSC_QGSC.hh"
 #include "HadronPhysicsQGSP.hh"
 #include "HadronPhysicsQGSP_BERT.hh"
@@ -76,8 +78,9 @@
 #include "HadronPhysicsQGSP_BIC.hh"
 #include "HadronPhysicsQGSP_BIC_HP.hh"
+#include "HadronPhysicsQGSP_FTFP_BERT.hh"
+#include "HadronPhysicsQGS_BIC.hh"
 
 #include "G4HadronInelasticQLHEP.hh"
 #include "G4IonPhysics.hh"
-#include "G4HadronProcessStore.hh"
 
 #include "G4LossTableManager.hh"
@@ -100,4 +103,5 @@
   cutForPositron  = defaultCutValue;
   dump            = false;
+  verboseLevel    = 1;
 
   pMessenger = new PhysicsListMessenger(this);
@@ -139,6 +143,4 @@
     hadronPhys[i]->ConstructProcess();
   }
-
-  if(dump) G4HadronProcessStore::Instance()->Dump(1);
 }
 
@@ -155,4 +157,9 @@
     emPhysicsList = new G4EmStandardPhysics_option2();
 
+  } else if (name == "emstandard_opt3") {
+
+    delete emPhysicsList;
+    emPhysicsList = new G4EmStandardPhysics_option3();
+
   } else if (name == "emstandard_opt1") {
 
@@ -160,9 +167,13 @@
     emPhysicsList = new G4EmStandardPhysics_option1();
 
-  } else if (name == "FTFC") {
-
-    SetBuilderList1();
-    hadronPhys.push_back( new HadronPhysicsFTFC("hadron",true));
-    dump = true;
+  } else if (name == "FTFP_BERT_EMV") {
+
+    AddPhysicsList("emstandard_opt1");
+    AddPhysicsList("FTFP_BERT");
+
+  } else if (name == "FTFP_BERT_EMX") {
+
+    AddPhysicsList("emstandard_opt2");
+    AddPhysicsList("FTFP_BERT");
 
   } else if (name == "FTFP") {
@@ -178,8 +189,15 @@
     dump = true;
 
-  } else if (name == "FTFP_EMV") {
-
-    AddPhysicsList("emstandard_opt1");
-    AddPhysicsList("FTFP");
+  } else if (name == "FTFP_BERT_TRV") {
+
+    SetBuilderList1();
+    hadronPhys.push_back( new HadronPhysicsFTFP_BERT_TRV("hadron",true));
+    dump = true;
+
+  } else if (name == "FTF_BIC") {
+
+    SetBuilderList0();
+    hadronPhys.push_back( new HadronPhysicsFTF_BIC("hadron",true));
+    dump = true;
 
   } else if (name == "LHEP") {
@@ -187,10 +205,4 @@
     SetBuilderList2();
     hadronPhys.push_back( new HadronPhysicsLHEP("hadron"));
-    dump = true;
-
-  } else if (name == "LHEP_BERT") {
-
-    SetBuilderList3();
-    hadronPhys.push_back( new HadronPhysicsLHEP_BERT("hadron"));
     dump = true;
 
@@ -202,15 +214,22 @@
     dump = true;
 
-  } else if (name == "LHEP_PRECO_HP") {
-
-    SetBuilderList3(true);
-    hadronPhys.push_back( new HadronPhysicsLHEP_PRECO_HP("hadron"));
-    dump = true;
-
   } else if (name == "QBBC") {
 
     SetBuilderList0();
     hadronPhys.push_back( new G4HadronInelasticQBBC("QBBC",verboseLevel,
-						    false,false,false,false,true));
+						    false,true,false,false,false));
+
+  } else if (name == "QBBCG") {
+
+    SetBuilderList0();
+    hadronPhys.push_back( new G4ChargeExchangePhysics(verboseLevel,false));
+    hadronPhys.push_back( new G4HadronInelasticQBBC("QBBC",verboseLevel,
+						    false,true,false,false,true));
+  } else if (name == "QBBCF") {
+
+    SetBuilderList0();
+    hadronPhys.push_back( new G4ChargeExchangePhysics(verboseLevel,false));
+    hadronPhys.push_back( new G4HadronInelasticQBBC("QBBC",verboseLevel,
+						    false,true,false,false,false));
 
   } else if (name == "QBBC_DEL") {
@@ -243,8 +262,14 @@
     dump = true;
 
-  } else if (name == "QGSC_EFLOW") {
+  } else if (name == "QGSC_CHIPS") {
 
     SetBuilderList4();
-    hadronPhys.push_back( new HadronPhysicsQGSC_EFLOW("hadron",true));
+    hadronPhys.push_back( new HadronPhysicsQGSC_CHIPS("hadron",true));
+    dump = true;
+
+  } else if (name == "QGSC_QGSC") {
+
+    SetBuilderList4();
+    hadronPhys.push_back( new HadronPhysicsQGSC_QGSC("hadron",true));
     dump = true;
 
@@ -266,4 +291,10 @@
     dump = true;
 
+  } else if (name == "QGSP_FTFP_BERT") {
+
+    SetBuilderList1();
+    hadronPhys.push_back( new HadronPhysicsQGSP_FTFP_BERT("hadron",true));
+    dump = true;
+
   } else if (name == "QGSP_BERT_EMV") {
 
@@ -271,4 +302,9 @@
     AddPhysicsList("QGSP_BERT");
 
+  } else if (name == "QGSP_BERT_EMX") {
+
+    AddPhysicsList("emstandard_opt2");
+    AddPhysicsList("QGSP_BERT");
+
   } else if (name == "QGSP_BERT_HP") {
 
@@ -282,4 +318,10 @@
     dump = true;
 
+  } else if (name == "QGS_BIC") {
+
+    SetBuilderList0();
+    hadronPhys.push_back( new HadronPhysicsQGS_BIC("hadron",true));
+    dump = true;
+
   } else if (name == "QGSP_BIC_HP") {
 
@@ -288,36 +330,8 @@
     dump = true;
 
-  } else if (name == "QGSP_DIF") {
-
-    SetBuilderList1();
-    HadronPhysicsQGSP * hp = new HadronPhysicsQGSP("hadron");
-    hp->SetQuasiElastic(true);
-    hp->SetProjectileDiffraction(true);
-    hadronPhys.push_back(hp);
-    dump = true;
-
-  } else if (name == "QGSP_EMV") {
-
-    AddPhysicsList("emstandard_opt1");
-    AddPhysicsList("QGSP");
-    dump = true;
-
-  } else if (name == "QGSP_EMX") {
-
-    AddPhysicsList("emstandard_opt2");
-    AddPhysicsList("QGSP");
-    dump = true;
-
-  } else if (name == "QGSP_NQE") {
-
-    SetBuilderList1();
-    hadronPhys.push_back( new HadronPhysicsQGSP("hadron",false));
-    dump = true;
-
-  } else if (name == "QGSP_QEL") {
-
-    SetBuilderList4();
-    hadronPhys.push_back( new HadronPhysicsQGSP("hadron",true));
-    dump = true;
+  } else if (name == "QGSP_BIC_EMY") {
+
+    AddPhysicsList("emstandard_opt3");
+    AddPhysicsList("QGSP_BIC");
 
   } else {
@@ -338,5 +352,5 @@
   hadronPhys.push_back( new G4QStoppingPhysics("stopping",verboseLevel));
   hadronPhys.push_back( new G4IonBinaryCascadePhysics("ionBIC"));
-  hadronPhys.push_back( new G4NeutronTrackingCut("Neutron tracking cut"));
+  hadronPhys.push_back( new G4NeutronTrackingCut("nTackingCut",verboseLevel));
 }
 
@@ -350,5 +364,5 @@
   hadronPhys.push_back( new G4QStoppingPhysics("stopping",verboseLevel));
   hadronPhys.push_back( new G4IonPhysics("ion"));
-  hadronPhys.push_back( new G4NeutronTrackingCut("Neutron tracking cut"));
+  hadronPhys.push_back( new G4NeutronTrackingCut("nTackingCut",verboseLevel));
 }
 
@@ -382,5 +396,5 @@
   hadronPhys.push_back( new G4QStoppingPhysics("stopping",verboseLevel));
   hadronPhys.push_back( new G4IonPhysics("ion"));
-  hadronPhys.push_back( new G4NeutronTrackingCut("Neutron tracking cut"));
+  hadronPhys.push_back( new G4NeutronTrackingCut("nTackingCut",verboseLevel));
 }
 
@@ -393,5 +407,5 @@
   hadronPhys.push_back( new G4QStoppingPhysics("stopping",verboseLevel));
   hadronPhys.push_back( new G4IonBinaryCascadePhysics("ionBIC"));
-  hadronPhys.push_back( new G4NeutronTrackingCut("Neutron tracking cut"));
+  hadronPhys.push_back( new G4NeutronTrackingCut("nTackingCut",verboseLevel));
 }
 
@@ -404,5 +418,5 @@
   hadronPhys.push_back( new G4QStoppingPhysics("stopping",verboseLevel));
   hadronPhys.push_back( new G4IonBinaryCascadePhysics("ionBIC"));
-  hadronPhys.push_back( new G4NeutronTrackingCut("Neutron tracking cut"));
+  hadronPhys.push_back( new G4NeutronTrackingCut("nTackingCut",verboseLevel));
 }
 
@@ -452,14 +466,12 @@
 void PhysicsList::List()
 {
-  G4cout << "### PhysicsLists available: FTFC FTFP FTFP_BERT FTFP_EMV LHEP LHEP_BERT LHEP_EMV "
+  G4cout << "### PhysicsLists available: FTFP FTFP_BERT FTFP_BERT_EMV FTFP_BERT_EMX FTFP_BERT_TRV FTF_BIC LHEP LHEP_EMV"
 	 << G4endl;
-  G4cout << "                            LHEP_PRECO_HP QBBC QBBC_DEL QBBC_HEL QBBC_HP QGSC "
+  G4cout << "                            QBBC QBBC_DEL QBBC_HEL QBBC_HP QGSC "
 	 << G4endl; 
-  G4cout << "                            QGSC_BERT QGSC_EFLOW QGSC_EMV QGSP QGSP_BERT QGSP_BER_EMV "
+  G4cout << "                            QGSC_BERT QGSC_CHIPS QGSC_QGSC QGSC_EMV QGSP QGSP_BERT QGSP_BER_EMV "
 	 << G4endl; 
-  G4cout << "                            QGSP_BERT_HP QGSP_BIC QGSP_BIC_HP QGSP_DIF " 
+  G4cout << "                            QGSP_BERT_EMX QGSP_BERT_HP QGSP_BIC QGSP_BIC_HP QGSP_FTFP_BERT " 
 	 << G4endl; 
-  G4cout << "                            QGSP_EMV QGSP_EMX QGSP_NQE QGSP_QEL  "
-	 << G4endl; 
 }
 
Index: trunk/examples/extended/hadronic/Hadr01/src/PhysicsListMessenger.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/PhysicsListMessenger.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/PhysicsListMessenger.cc	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: PhysicsListMessenger.cc,v 1.4 2006/08/11 14:38:11 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //
Index: trunk/examples/extended/hadronic/Hadr01/src/PrimaryGeneratorAction.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/PrimaryGeneratorAction.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/PrimaryGeneratorAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorAction.cc,v 1.4 2006/11/15 14:58:10 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 /////////////////////////////////////////////////////////////////////////
Index: trunk/examples/extended/hadronic/Hadr01/src/RunAction.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/RunAction.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/RunAction.cc	(revision 1230)
@@ -40,5 +40,4 @@
 #include "G4UImanager.hh"
 #include "G4VVisManager.hh"
-#include "G4HadronProcessStore.hh"
 #include "G4NistManager.hh"
 #include "G4Element.hh"
Index: trunk/examples/extended/hadronic/Hadr01/src/StackingAction.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/StackingAction.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/StackingAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StackingAction.cc,v 1.5 2006/10/04 09:56:03 vnivanch Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 /////////////////////////////////////////////////////////////////////////
Index: trunk/examples/extended/hadronic/Hadr01/src/StackingMessenger.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/StackingMessenger.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/StackingMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StackingMessenger.cc,v 1.3 2006/06/29 17:24:32 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 /////////////////////////////////////////////////////////////////////////
Index: trunk/examples/extended/hadronic/Hadr01/src/TargetSD.cc
===================================================================
--- trunk/examples/extended/hadronic/Hadr01/src/TargetSD.cc	(revision 1187)
+++ trunk/examples/extended/hadronic/Hadr01/src/TargetSD.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: TargetSD.cc,v 1.4 2006/06/29 17:24:34 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 /////////////////////////////////////////////////////////////////////////
Index: trunk/examples/extended/medical/DICOM/dicom.cc
===================================================================
--- trunk/examples/extended/medical/DICOM/dicom.cc	(revision 1187)
+++ trunk/examples/extended/medical/DICOM/dicom.cc	(revision 1230)
@@ -56,4 +56,5 @@
 #include "DicomPrimaryGeneratorAction.hh"
 #include "DicomEventAction.hh"
+#include "DicomRunAction.hh"
 #include "DicomHandler.hh"
 
@@ -77,5 +78,6 @@
   runManager->SetUserInitialization(theGeometry);
   runManager->SetUserAction(new DicomPrimaryGeneratorAction());
-  //  runManager->SetUserAction(new DicomEventAction);
+  runManager->SetUserAction(new DicomRunAction);
+  runManager->SetUserAction(new DicomEventAction);
 
   runManager->Initialize();
Index: trunk/examples/extended/medical/DICOM/include/DicomDetectorConstruction.hh
===================================================================
--- trunk/examples/extended/medical/DICOM/include/DicomDetectorConstruction.hh	(revision 1187)
+++ trunk/examples/extended/medical/DICOM/include/DicomDetectorConstruction.hh	(revision 1230)
@@ -79,4 +79,6 @@
   // construct the patient volumes. This method should be implemented for each of the derived classes
 
+  void SetScorer(G4LogicalVolume* voxel_logic);
+
 protected:
   G4Material* air;
Index: trunk/examples/extended/medical/DICOM/include/DicomNestedPhantomParameterisation.hh
===================================================================
--- trunk/examples/extended/medical/DICOM/include/DicomNestedPhantomParameterisation.hh	(revision 1187)
+++ trunk/examples/extended/medical/DICOM/include/DicomNestedPhantomParameterisation.hh	(revision 1230)
@@ -24,11 +24,16 @@
 // ********************************************************************
 //
-#ifndef RE02NESTEDPARAMETERISATION_HH
-#define RE02NESTEDPARAMETERISATION_HH
+// $Id: DicomNestedPhantomParameterisation.hh,v 1.3 2009/01/27 10:44:58 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
+//
+// --------------------------------------------------------------------
+#ifndef DICOMNESTEDPARAMETERISATION_HH
+#define DICOMNESTEDPARAMETERISATION_HH
+
+#include <vector>
 
 #include "G4Types.hh"
+#include "G4ThreeVector.hh"
 #include "G4VNestedParameterisation.hh" 
-#include "G4ThreeVector.hh"
-#include <vector>
 
 class G4VPhysicalVolume;
@@ -52,78 +57,68 @@
 class G4Hype;
 
-class DicomNestedPhantomParameterisation: public G4VNestedParameterisation
+class DicomNestedPhantomParameterisation : public G4VNestedParameterisation
 {
-  public:  // with description
+  public:
 
     DicomNestedPhantomParameterisation(const G4ThreeVector& voxelSize,
-				      std::vector<G4Material*>& mat);
+                                       std::vector<G4Material*>& mat);
     virtual ~DicomNestedPhantomParameterisation(); 
 
-    // Methods required in derived classes
-    // -----------------------------------
-    virtual G4Material* ComputeMaterial(G4VPhysicalVolume *currentVol,
-					const G4int repNo, 
-                                        const G4VTouchable *parentTouch=0
-                                        );
-  // Required method, as it is the reason for this class.
-  //   Must cope with parentTouch=0 for navigator's SetupHierarchy
+    G4Material* ComputeMaterial(G4VPhysicalVolume *currentVol,
+                                const G4int repNo, 
+                                const G4VTouchable *parentTouch );
+      // Must cope with parentTouch for navigator's SetupHierarchy
 
-    virtual G4int       GetNumberOfMaterials() const;
-    virtual G4Material* GetMaterial(G4int idx) const;
+    G4int       GetNumberOfMaterials() const;
+    G4Material* GetMaterial(G4int idx) const;
       // Needed to define materials for instances of Nested Parameterisation 
-      //   Current convention: each call should return the materials 
-      //   of all instances with the same mother/ancestor volume.
+      // Current convention: each call should return the materials 
+      // of all instances with the same mother/ancestor volume
+
     size_t GetMaterialIndex( size_t nx, size_t ny, size_t nz) const;
     size_t GetMaterialIndex( size_t copyNo) const;
-    void SetMaterialIndices( size_t* matInd ){
-      fMaterialIndices = matInd; }
+    void SetMaterialIndices( size_t* matInd ) { fMaterialIndices = matInd; }
     void SetNoVoxel( size_t nx, size_t ny, size_t nz );
 
-    virtual void ComputeTransformation(const G4int no,
-                                       G4VPhysicalVolume *currentPV) const;
-
-    // Methods optional in derived classes
-    // -----------------------------------
+    void ComputeTransformation(const G4int no,
+                                     G4VPhysicalVolume *currentPV) const;
 
     // Additional standard Parameterisation methods, 
-    //   which can be optionally defined, in case solid is used.
+    // which can be optionally defined, in case solid is used.
 
-    virtual void ComputeDimensions(G4Box &,
-                                   const G4int,
-                                   const G4VPhysicalVolume *) const;
+    void ComputeDimensions(G4Box &, const G4int,
+                                    const G4VPhysicalVolume *) const;
 
-private:  // Dummy declarations to get rid of warnings ...
-  void ComputeDimensions (G4Trd&,const G4int,const G4VPhysicalVolume*) 
-    const {}
-  void ComputeDimensions (G4Trap&,const G4int,const G4VPhysicalVolume*) 
-    const {}
-  void ComputeDimensions (G4Cons&,const G4int,const G4VPhysicalVolume*) 
-    const {}
-  void ComputeDimensions (G4Sphere&,const G4int,const G4VPhysicalVolume*) 
-    const {}
-  void ComputeDimensions (G4Orb&,const G4int,const G4VPhysicalVolume*) 
-    const {}
-  void ComputeDimensions (G4Torus&,const G4int,const G4VPhysicalVolume*) 
-    const {}
-  void ComputeDimensions (G4Para&,const G4int,const G4VPhysicalVolume*) 
-    const {}
-  void ComputeDimensions (G4Hype&,const G4int,const G4VPhysicalVolume*) 
-    const {}
-  void ComputeDimensions (G4Tubs&,const G4int,const G4VPhysicalVolume*) 
-    const {}
-  void ComputeDimensions (G4Polycone&,const G4int,const G4VPhysicalVolume*)
-    const {}
-  void ComputeDimensions (G4Polyhedra&,const G4int,const G4VPhysicalVolume*) 
-    const {}
+  private:  // Dummy declarations to get rid of warnings ...
 
-private:
-  G4double fdX,fdY,fdZ;
-  G4int fnX,fnY,fnZ;
-  
-  //
-  std::vector<G4Material*> fMaterials;
+    void ComputeDimensions (G4Trd&, const G4int,
+                            const G4VPhysicalVolume*) const {}
+    void ComputeDimensions (G4Trap&, const G4int,
+                            const G4VPhysicalVolume*) const {}
+    void ComputeDimensions (G4Cons&, const G4int,
+                            const G4VPhysicalVolume*) const {}
+    void ComputeDimensions (G4Sphere&, const G4int,
+                            const G4VPhysicalVolume*) const {}
+    void ComputeDimensions (G4Orb&, const G4int,
+                            const G4VPhysicalVolume*) const {}
+    void ComputeDimensions (G4Torus&, const G4int,
+                            const G4VPhysicalVolume*) const {}
+    void ComputeDimensions (G4Para&, const G4int,
+                            const G4VPhysicalVolume*) const {}
+    void ComputeDimensions (G4Hype&, const G4int,
+                            const G4VPhysicalVolume*) const {}
+    void ComputeDimensions (G4Tubs&, const G4int,
+                            const G4VPhysicalVolume*) const {}
+    void ComputeDimensions (G4Polycone&, const G4int,
+                            const G4VPhysicalVolume*) const {}
+    void ComputeDimensions (G4Polyhedra&, const G4int,
+                            const G4VPhysicalVolume*) const {}
 
-  size_t* fMaterialIndices;
-      // Index in fMaterials that correspond to each voxel.
+  private:
+
+    G4double fdX,fdY,fdZ;
+    G4int fnX,fnY,fnZ;
+    std::vector<G4Material*> fMaterials;
+    size_t* fMaterialIndices; // Index in materials corresponding to each voxel
 };
 
Index: trunk/examples/extended/medical/DICOM/src/DicomDetectorConstruction.cc
===================================================================
--- trunk/examples/extended/medical/DICOM/src/DicomDetectorConstruction.cc	(revision 1187)
+++ trunk/examples/extended/medical/DICOM/src/DicomDetectorConstruction.cc	(revision 1230)
@@ -451,2 +451,31 @@
 }
 
+
+#include "G4SDManager.hh"
+#include "G4MultiFunctionalDetector.hh"
+#include "G4PSDoseDeposit_RegNav.hh"
+
+//-------------------------------------------------------------
+void DicomDetectorConstruction::SetScorer(G4LogicalVolume* voxel_logic)
+{
+
+  G4SDManager* SDman = G4SDManager::GetSDMpointer();
+  //
+  // Sensitive Detector Name
+  G4String concreteSDname = "PatientSD";
+
+  //------------------------
+  // MultiFunctionalDetector
+  //------------------------
+  //
+  // Define MultiFunctionalDetector with name.
+  G4MultiFunctionalDetector* MFDet = new G4MultiFunctionalDetector(concreteSDname);
+  SDman->AddNewDetector( MFDet );                 // Register SD to SDManager
+
+  voxel_logic->SetSensitiveDetector(MFDet);
+
+  G4PSDoseDeposit_RegNav*   scorer = new G4PSDoseDeposit_RegNav("DoseDeposit");  
+  MFDet->RegisterPrimitive(scorer);
+
+}
+
